﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows;

namespace WPFTreeViewInPanelBar
{
	public class MainPageViewModel : BaseViewModel
	{
		private ObservableCollection<EmailTypesViewModel> domainEmailTypes;
		private bool? isDomainsChecked;

		public MainPageViewModel()
		{
			LoadData();
		}

		private void LoadData()
		{
			this.domainEmailTypes = new ObservableCollection<EmailTypesViewModel>();
			var item1 = new EmailTypesViewModel { Name = "1", DisplayCount = "-5-" };
			var item11 = new EmailTypesViewModel { Name = "1.1", DisplayCount = "-1-" };
			item11.EmailTypes.Add(new EmailTypesViewModel { Name = "1.1.1" });
			item1.EmailTypes.Add(item11);
			item1.EmailTypes.Add(new EmailTypesViewModel { Name = "1.2", DisplayCount = "-0-" });
			item1.EmailTypes.Add(new EmailTypesViewModel { Name = "1.3", DisplayCount = "-0-" });
			item1.EmailTypes.Add(new EmailTypesViewModel { Name = "1.4", DisplayCount = "-0-" });
			item1.EmailTypes.Add(new EmailTypesViewModel { Name = "1.5", DisplayCount = "-0-" });
			DomainEmailTypes.Add(item1);
			DomainEmailTypes.Add(new EmailTypesViewModel { Name = "2", DisplayCount = "-1-", IsChecked = true });
			DomainEmailTypes.Add(new EmailTypesViewModel { Name = "3", DisplayCount = "-1-", IsChecked = true });
			DomainEmailTypes.Add(new EmailTypesViewModel { Name = "4", DisplayCount = "-1-" });
			DomainEmailTypes.Add(new EmailTypesViewModel { Name = "5", DisplayCount = "-1-" });
		}

		public ObservableCollection<EmailTypesViewModel> DomainEmailTypes
		{
			get
			{
				return this.domainEmailTypes;
			}
		}

		public bool? IsDomainsChecked
		{
			get
			{
				return this.isDomainsChecked;
			}
			set
			{
				this.isDomainsChecked = value;
				OnPropertyChanged("IsDomainsChecked");
				if (this.isDomainsChecked == true )
				{
					ChangeAllValues(true);
				}
				else if (this.isDomainsChecked == false)
				{
					ChangeAllValues(false);
				}
				else
				{
					ChangeAllValues(null);
				}
			}
		}

		private void ChangeAllValues(bool? value)
		{
			foreach (var item in domainEmailTypes)
			{
				AllChildsValueChange(item, value);
			}
		}

		private void AllChildsValueChange(EmailTypesViewModel item ,bool? value)
		{
			item.IsChecked = value;
			foreach (var child in item.EmailTypes)
			{
				AllChildsValueChange(child, value);
			}
		}
	}
}
